Status: Closed

Priority: Normal

Assignee: Nathan Woodrow

Category: Data Provider/MSSQL

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 22558
Description

When loading a layer into QGIS which contains invalid features QGIS fails to completely render the layer and stops on any invalid feature
without any error message to the user. This leaves the user confused as to what has occurred.

The reason for this is the MSSQL spatial filtering process using ST_Intersects which will throw an exception if the feature is not valid. e.g

SELECT [id],[ogr_geometry]FROM [dbo].[invalid_parcels] where [ogr_geometry].STIntersects([geometry]::STGeomFromText('
POLYGON)',4326)) = 1

might throw this error:

Msg 6522, Level 16, State 1, Line 5
A NET Framework error occurred during execution of user-defined routine or aggregate "geometry":
System.ArgumentException: 24144: This operation cannot be completed because the instance is not valid. Use MakeValid to convert the
instance to a valid instance. Note that MakeValid may cause the points of a geometry instance to shift slightly.
System.ArgumentException:

at Microsoft.SqlServer. Types.SqlGeometry. Throwlflnvalid()

at Microsoft.SqlServer. Types.SqlGeometry.STIntersects(SglGeometry other)

A couple options here:

1/ At least raise an error with the user that the layer contains invalid features and to fix them.

2/ Use Fliter instead or STIntersect for the spatial filtering function as Filter can operate on invalid geometries. This might also make
sense due to performance reasons. See #10947.

| vote for 2!

| have attached a screenshot showing what happens in a typical situation in the map window. | have also attached a SQL dump of a test
layer which contains invalid geometries.

History

#1 - 2016-03-30 03:56 PM - Nathan Woodrow
- Assignee set to Nathan Woodrow
- Priority changed from Normal to High

Hmm bugger. Yeah using Filter is the way to go. | will fix this next week if you are not in a rush. Will back port it as much as | can.
#2 - 2016-03-30 07:12 PM - Jeremy Palmer
No rush. Thanks.

#3 - 2016-04-09 08:14 AM - Giovanni Manghi
- OS version deleted (ALL)

- Operating System deleted (ALL)

- Target version deleted (Version 2.16)

- Priority changed from High to Normal

#4 - 2016-04-29 02:44 AM - Jeremy Palmer

Nathan any update on this?

#5 - 2016-06-24 10:21 PM - Nathan Woodrow

| have fixed this is in master using a IsValid() check however | think | will try the Filter method before release.

#6 - 2017-05-01 01:05 AM - Giovanni Manghi
- Regression? set to No
- Easy fix? set to No

#7 - 2017-05-08 03:42 PM - Nathan Woodrow
- Status changed from Open to Closed

- Description updated

- Resolution set to fixed/implemented
